function generateImageIndexes()

RESULTADOS = [];
INDICES = [];
FILEINFO = [];

%**************** INPUT ARGUMENTS *****************
%folder containing the images folders
%baseDir =   '/mnt/data/academic/DISSERTATION/segmentation_results/EVALUATION/segment_selecteds2/to_Evaluate';
baseDir =   '/mnt/data/academic/DISSERTATION/segmentation_results/EVALUATION/segment_selecteds4/toEvaluate/MS_results';

%folder where the results will be stored
%outputDir = '/mnt/data/academic/DISSERTATION/segmentation_results/EVALUATION/segment_selecteds2/to_Evaluate';
outputDir = '/mnt/data/academic/DISSERTATION/segmentation_results/EVALUATION/segment_selecteds4/toEvaluate/MS_results'

%expected extension of the images to be evaluated
imageExt = 'png';

%expected extension of the ground truth files
gtExt = 'seg'; %'seg'; % or 'png';

%folder containing the human segmentations
gtDir =   '/mnt/data/academic/DISSERTATION/segmentation_results/EVALUATION/berkeley_bsd/human_seg';


%clear output and list directories to be processed
%[stat] = unix(['rm ' outputDir '/results.dat']);
[stat listOfDir] = unix(['ls -1 ' baseDir]);
listOfDir = split_lines(listOfDir);


%iterate over all images
for cont = 1 : size(listOfDir,1)

    imageDir=listOfDir(cont,:);
    [imageNumber remainerInfo] = extractImageNumber(imageDir);
    
    %convert all ppm images of this directory to png format
    %[ 'Converting to png format - ' true_value]
    %ppm2png(baseDir, true_value);
    
    %getting name of the image file to be evaluted
    %WARNING: make sure there is EXACLTY ONE image file of the specified type
    %in each image directory
    
    
    if(length(remainerInfo) == 0)
        [stat listOfFiles] = unix(['find ' baseDir '/' num2str(imageNumber) ' -name *.' imageExt]);
    else
        [stat listOfFiles] = unix(['find ' baseDir '/' num2str(imageNumber) '-' remainerInfo ' -name *.' imageExt]);
    end
    listOfFiles = split_lines(listOfFiles);
    
    %iterate over segmented results to compare with GT's
    for contSeg = 1 : size(listOfFiles, 1)
      
          filePath = listOfFiles(contSeg,:);
          [ 'Image: ' filePath ]

          %--------------------------------
          %Load segmented image
          MS = [];
          nSegsMS = 0;
          hist = [];
          [ 'Labeling image ...' ]

          if imageExt == 'seg'
                [MS, nSegsMS] = berkeleyImLoadBySegments(filePath);
          else
                [MS, nSegsMS, hist] = im2segs2(filePath);  
          end;  

          [ 'Image labeled, ' int2str(nSegsMS) ' segments' ]

          %code to compute the cardinality of the MS subset
          cardMS = cardinalityMatrix(MS);
          %code for compute the number of elements
          n = size(MS,1) * size(MS,2);

          [stat listOfSegs] = unix(['find ' gtDir '/' ...
                                     ' -name ' num2str(imageNumber) '*.' gtExt]);
          listOfSegs = split_lines(listOfSegs);
          
          for contEval = 1 : size(listOfSegs,1)

                  [ 'Comparing to ground truth ' int2str(contEval)  '/' int2str(size(listOfSegs,1)) ]

                  pathGT = listOfSegs(contEval,:);                     
                  observerID=extractObserverNumber(pathGT);
                  %--------------------------------
                  %Load GT image
                  GT = [];
                  nSegsGT = 0;
                  [GT, nSegsGT] = berkeleyImLoadBySegments(pathGT);

                  %code for computing the cardinality of each subset
                  cardGT = cardinalityMatrix(GT);

                  %code for computing the confusion matrix
                  confuMat = confusionMat(MS, GT, nSegsMS, nSegsGT);

                  %code for computing the Nxx indexes
                  [N00, N01, N10, N11] = calcNxx( confuMat, MS, GT, nSegsMS, ...
                    nSegsGT, cardMS, cardGT);
                  %[N00, N01, N10, N11]
                  %----------------------------------------------
                  %(1) CR e ER
                  %statsCR_ER = [];
                  %minCorrelation = 0.8; %parameter

                  %for contMS = 1 : nSegsMS
                  %  for contGT = 1 : nSegsGT
                  %    %calc the first stat CR e ER
                  %    [cr, er] = CRandER(MS, GT, contMS, contGT);
                  %    if (cr >= minCorrelation)
                  %      statsCR_ER(size(statsCR_ER,1)+1,:) = [contMS, contGT, cr, er];
                  %    end;
                  %  end;
                  %end;
                  %save([pathGT, '.ER_CR_file'], statsCR_ER); 

                  %----------------------------------------------
                  %(2) The rand index
                  %R(C1,C2)
                  randIndex = 1 - ((N11 + N00) / ((n *(n-1)) /2));

                  %----------------------------------------------
                  %(3) Fowlkes & Mallows index
                  W1 = 0;
                  W2 = 0;
                  for i = 1 : nSegsMS
                    W1 = W1 + ((cardMS(i)*(cardMS(i) - 1)) /2);
                  end;
                  W1 = N11 / W1;
                  for j = 1 : nSegsGT
                    W2 = W2 + ((cardGT(j)*(cardGT(j) - 1)) /2);
                  end;
                  W2 = N11 / W2;
                  FowlkesMallows = 1 - sqrt(W1*W2);

                  %----------------------------------------------
                  %(4) Jacard Index
                  Jacard = 1 - (N11 / (N11 + N10 + N01));

                  %----------------------------------------------
                  %(5) Dongen Index (Metric)
                  lastIndex = max(max(MS));
                  aC1C2 = 0;
                  for cont2 = 1 : lastIndex
                    [tmp, indMaxMS] = maxIntersectMod(MS,GT,cont2);
                    aC1C2 = aC1C2 + tmp;
                  end;

                  %aC2C1
                  lastIndex = max(max(GT));
                  aC2C1 = 0;
                  for cont2 = 1 : lastIndex
                    [tmp, indMaxMS] = maxIntersectMod(GT,MS,cont2);
                    aC2C1 = aC2C1 + tmp;
                  end;

                  Dongen = 2*n - aC1C2 - aC2C1;
                  Dongen = Dongen / n;

                  %----------------------------------------------
                  %(6) Bipartite Graph matching
                  w = 0;
                  for cGT = 1 : size(confuMat,2)
                    w = w + max(confuMat(:,cGT));
                  end;
                  BGM = 1 - (w / n);

                  RESULTADOS = [
                    randIndex,...
                    FowlkesMallows,...
                    Jacard,...
                    Dongen, ...
                    BGM];

                  INDICES = [
                    contEval,...
                    nSegsMS,...
                    nSegsGT, ...
                    n];

                  [ 'Indices generated, saving ...' ]

                  %saving data into file
                  saveFile([outputDir '/results.dat'], imageNumber, remainerInfo, filePath, RESULTADOS, contEval, observerID, nSegsMS, nSegsGT);

                  [ 'Indices saved' ]

           end; %for evals number
      end; %for segmented images number
end; %for directory images

fprintf('PROCESSO ENCERRADO!\n');

sucess = 1;

sucess;
